SystemOrganization addCategory: #'OB-Enhancements-SmartGroup'!
SystemOrganization addCategory: #'OB-Enhancements-MultipleSelection'!
SystemOrganization addCategory: #'OB-Enhancements-Commands'!
SystemOrganization addCategory: #'OB-Enhancements-Morphs'!
SystemOrganization addCategory: #'OB-Enhancements-Panels'!

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 7/19/2007 11:48'!
panel
	^panel ! !

OBColumn subclass: #OBMultipleSelectionColumn
	instanceVariableNames: 'multipleSelection oldSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-MultipleSelection'!

!OBMultipleSelectionColumn methodsFor: 'building' stamp: 'dr 7/4/2007 15:51'!
buildOn: aBuilder
	^ aBuilder
		multipleSelectionColumn: self 
		with: [switch buildOn: aBuilder]! !

!OBMultipleSelectionColumn methodsFor: 'selecting' stamp: 'dr 5/29/2007 14:56'!
clearSelection
	super clearSelection.
	multipleSelection := Dictionary new.! !

!OBMultipleSelectionColumn methodsFor: 'morphic' stamp: 'dr 7/4/2007 15:50'!
listMorph
	^ (OBPluggableListMorphOfMany
		on: self
		list: #list
		primarySelection: #selection
		changePrimarySelection: #selection:
		listSelection: #listSelectionAt:
		changeListSelection: #listSelectionAt:put:		
		menu: #menu: 
		keystroke: #keystroke:from:)
			getListElementSelector: #listAt:;
			getListSizeSelector: #listSize;
			dragEnabled: self dragEnabled;
			dropEnabled: self dropEnabled;
			borderWidth: 0;
			autoDeselect: false;
			adoptPaneColor: panel defaultBackgroundColor;
			yourself! !

!OBMultipleSelectionColumn methodsFor: 'callbacks' stamp: 'dr 5/29/2007 14:55'!
listSelectionAt: anIndex
	^multipleSelection at: anIndex ifAbsent: [^false]! !

!OBMultipleSelectionColumn methodsFor: 'callbacks' stamp: 'dr 7/4/2007 17:21'!
listSelectionAt: anIndex put: aValue 
     | isSelected |
     isSelected := multipleSelection at: anIndex ifAbsent: [false].

     "if we did not de-select the primary selection"
     (aValue not and: [anIndex = selection]) ifFalse: [
	     multipleSelection at: anIndex put: aValue.
          "if we de-select this item"
	     (isSelected = true and: [aValue not]) ifTrue: [
		    self announcer announce: ((OBSelectionChanged column: self) deselectedNode: (children at: anIndex)).
	     ] ifFalse: [ "if we select an new item => check all old items"
	         (multipleSelection associationsDo: [:assoc | (assoc value = true and: [self paneExistsForSelection: assoc key]) ifFalse: [
			    multipleSelection at: assoc key put: false.
			]])
	     ]
     ].! !

!OBMultipleSelectionColumn methodsFor: 'testing' stamp: 'dr 7/4/2007 15:50'!
paneExistsForSelection: anIndex
    ^panel definitionPanel includesNode: (self getChildren at: anIndex).! !

!OBMultipleSelectionColumn methodsFor: 'selecting' stamp: 'dr 7/4/2007 15:50'!
preselectNodes
     self getChildren keysAndValuesDo: [:idx :node | (panel definitionPanel includesNode: node) ifTrue: [multipleSelection at: idx put: true]]. ! !

!OBMultipleSelectionColumn methodsFor: 'callbacks' stamp: 'dr 7/4/2007 15:50'!
selection: anInteger
     "de-selected an item"
	anInteger = 0 ifTrue: [
         "primarySelection := oldPrimarySelection. self halt."
         "selection keysAndValuesDo: [:index :value | value ifTrue: [primarySelection := index]]."
	] ifFalse: [ 
	    oldSelection := selection.
	    selection _ anInteger.
	    (multipleSelection isEmpty and: [self = panel columns last]) ifTrue: [multipleSelection at: anInteger put: true].
         self signalSelectionChanged.
	]. 
	self changed: #selection.
! !

OBColumn subclass: #OBSmartGroupColumn
	instanceVariableNames: 'smartGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartGroupColumn methodsFor: 'updating' stamp: 'dr 6/7/2007 16:30'!
childrenChanged: announcement
	(announcement node isKindOf: OBSmartGroupNode) ifTrue:
		[self refresh].! !

!OBSmartGroupColumn methodsFor: 'nodes' stamp: 'dr 7/4/2007 15:50'!
nextMetaNode
    ^panel root metaNode! !

!OBSmartGroupColumn methodsFor: 'accessing' stamp: 'dr 4/5/2007 14:48'!
parent
	^smartGroup! !

!OBSmartGroupColumn methodsFor: 'accessing' stamp: 'dr 4/16/2007 16:16'!
selectedNode
	^children at: self selection ifAbsent: [panel root].! !

!OBSmartGroupColumn methodsFor: 'nodes' stamp: 'dr 7/4/2007 15:50'!
selectionChanged: ann
    (ann node respondsTo: #alias) ifTrue: [panel jumpTo: ann node alias].! !

!OBSmartGroupColumn methodsFor: 'initializing' stamp: 'dr 7/19/2007 10:32'!
setPanel: aPanel metaNode: aMetaNode node: aNode
    smartGroup := aNode.
    super setPanel: aPanel metaNode: aMetaNode node: aNode.
    ! !

!OBSmartGroupColumn methodsFor: 'updating' stamp: 'dr 5/29/2007 10:58'!
subscribe
    super subscribe.
    self announcer observe: OBSelectionChanged send: #selectionChanged: to: self.! !

OBDefinitionPanel subclass: #OBClosableDefinitionPanel
	instanceVariableNames: 'node morph isPinned owner contentMorph codeTabPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/8/2007 15:54'!
asDraggableMorph
	^(StringMorph contents: '*')
		color: Color white;
		yourself! !

!OBClosableDefinitionPanel methodsFor: 'building' stamp: 'dr 7/18/2007 15:25'!
buildOn: aBuilder
    morph ifNil: [morph := aBuilder closableDefinitionPanel: self with: []].
    ^morph! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/29/2007 16:27'!
changed
    self codeTabPanel selection = 1 ifFalse: [self codeTabPanel selection: 1.].! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
classLabel
	| classLabel |
	classLabel := self className.
	self node ifNotNil: [self node isMethodHolderNode ifTrue: [classLabel := classLabel,' >>']].
	^classLabel! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
className
     ^self methodClass ifNotNil: [self methodClass name] ifNil: ['']! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 5/29/2007 11:26'!
close
   browser definitionPanel panels size < 2 ifTrue: [^self inform: 'You cannot close the last panel.'].
   browser definitionPanel removePanel: self column: nil.! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 5/29/2007 11:26'!
closeLabel
	^ (StringMorph 
		contents: 'x'
		font: ("TextStyle defaultFont" StrikeFontSet familyName: 'Accouny14' size: 10))
			color: Color red;
			yourself! !

!OBClosableDefinitionPanel methodsFor: 'building' stamp: 'dr 6/29/2007 15:22'!
codeTabPanel
    codeTabPanel ifNil: [codeTabPanel := (OBCodeTabPanel new browser: browser; definitionPanel: self; yourself)].
    ^codeTabPanel! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/22/2007 16:49'!
color
	^browser defaultBackgroundColor ! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/22/2007 16:45'!
commands
	| myNode |
	myNode _ self currentNode.
	myNode ifNil: [^ #()].
     ^{OBCmdSystemComplexity on: myNode for: self. OBCmdUmlDiagram on: myNode for: self}
    ! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 7/12/2007 13:55'!
createClassLabel
	| classLabel |		
     classLabel := (StringMorph 
		contents: (Text string: self classLabel attribute: TextEmphasis bold)	
		font: (StrikeFontSet familyName: #NewYork size: 10))
			color: Color black;
			yourself.
	classLabel on: #mouseDown send: #selectClass to: self.			
	classLabel hResizing: #spaceFill; vResizing: #spaceFill; setWidth: 100; height: 20.						
			
	^classLabel		! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/5/2007 17:45'!
createCloseButton						
	^PluggableButtonMorph
		on: self
		getState: #isSelected
		action: #close
		label: #closeLabel.! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/29/2007 16:07'!
createContentMorph
	| textEditor |
	
	textEditor := (MorphicTextEditor default
		on: self
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:)
		font: Preferences standardCodeFont;
		yourself.
	textEditor 
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderWidth: 0;
		color: Color white.
     ^textEditor! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/12/2007 15:20'!
createDragButton
	| dragButton paneColor |
	dragButton := OBDraggableButtonMorph 
				on: self
				getState: #isDragged
				action: #drag
				label: #dragLabel.
	dragButton enableDragNDrop.
	paneColor := browser defaultBackgroundColor.
	dragButton onColor: Color lightGray lighter offColor: paneColor.
	^ dragButton! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 7/19/2007 14:05'!
createMorph			
     morph := nil.						
	^self buildOn: OBMorphBuilder new		! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/12/2007 15:20'!
createPinButton
	| pinButton paneColor |
	pinButton := OBDraggableButtonMorph 
				on: self
				getState: #isPinned
				action: #pin
				label: #pinLabel.
	paneColor := browser defaultBackgroundColor.
	pinButton onColor: Color lightGray lighter offColor: paneColor.
	^ pinButton! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/11/2007 11:48'!
createTitleBar
	| titleBar |		
	titleBar := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		borderWidth: 0;
		"borderColor: Color black;"
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.
			
	titleBar addMorphBack: self createClassLabel; 
	          addMorphBack: self createDragButton; 
	          addMorphBack: self createPinButton; 
	          addMorphBack: self createCloseButton.			
	^titleBar		! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/29/2007 15:50'!
currentNode
    ^self node ifNil: [super currentNode]! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 16:00'!
currentOrRootNode
    ^self node ifNil: [super currentOrRootNode]! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/11/2007 11:47'!
drag
    "do nothing"! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/11/2007 11:49'!
dragLabel
	^ (StringMorph 
		contents: '<- ->'
		font: (StrikeFontSet familyName: 'Accouny14' size: 10))
			color: Color red;
			yourself! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:43'!
dropMorph: aMorph
    | panelToBeMoved |
    panelToBeMoved := aMorph passenger.

    (self isPlacedBefore: panelToBeMoved) ifTrue: [
	   panelToBeMoved insertBefore: self. 
    ] ifFalse: [
        panelToBeMoved insertAfter: self.
    ].! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/29/2007 15:34'!
exchangeContentWith: aMorph
    morph removeMorph: contentMorph. 
    aMorph vResizing: #spaceFill.
    contentMorph := aMorph. 
    morph addMorphBack: contentMorph.! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/29/2007 15:59'!
getDefinition
     definition ifNotNil: [^definition].
	^ browser currentNode ifNotNilDo: [:ea | ea definition]! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 7/18/2007 15:32'!
hasSeveralPanels	
	^browser definitionPanel panels size > 1! !

!OBClosableDefinitionPanel methodsFor: 'initializing' stamp: 'dr 6/7/2007 11:20'!
initialize
    isPinned := false! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/8/2007 16:33'!
insertAfter: aPanel
    ^self owner insert: self after: aPanel! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:44'!
insertBefore: aPanel
    ^self owner insert: self before: aPanel! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/7/2007 11:36'!
isChangeable
    ^self isPinned not! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/11/2007 11:47'!
isDragged
    ^false! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/6/2007 15:59'!
isPinned
    ^isPinned! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:35'!
isPlacedBefore: aClosableDefinitionPanel
    ^self owner is: self placedBefore: aClosableDefinitionPanel! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 5/29/2007 11:26'!
isSelected
    ^false
   ! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
methodClass
     ^(self node respondsTo: #theClass) ifTrue: [self node theClass] ifFalse: [nil]! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 7/18/2007 15:41'!
morph
	^morph
! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/29/2007 11:45'!
node
    ^node! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/29/2007 15:15'!
node: aNode
    node := aNode. 
    "self selectSourceTab."! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/8/2007 16:16'!
owner
	^owner! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/8/2007 16:16'!
owner: aMultipleDefinitionPanel
	owner := aMultipleDefinitionPanel! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/7/2007 11:50'!
pin
    self isPinned ifTrue: [isPinned := false] ifFalse: [isPinned := true] ! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/6/2007 15:20'!
pinLabel
	^ (StringMorph 
		contents: '!!'
		font: (StrikeFontSet familyName: 'Accouny14' size: 10))
			color: Color red;
			yourself! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
selectClass
    browser jumpTo: (OBClassNode on: self methodClass)! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/29/2007 16:31'!
selectSourceTab
    self exchangeContentWith: self createContentMorph.! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 7/18/2007 15:35'!
setContentMorph: aMorph
    contentMorph := aMorph! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/6/2007 15:59'!
setIsPinned
    isPinned := true! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/8/2007 16:19'!
swapWith: aPanel
    ^self owner swap: self with: aPanel! !

!OBDefinitionPanel methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 15:39'!
currentNode
	^browser currentNode! !

!OBDefinitionPanel methodsFor: '*ob-enhancements' stamp: 'dr 7/19/2007 16:00'!
currentOrRootNode
	^browser currentOrRootNode! !

OBDefinitionPanel subclass: #OBMondrianPanel
	instanceVariableNames: 'visualization contentMorph node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 7/3/2007 14:58'!
classBlueprint
    self setVisualization: #classBlueprint.
    ^self morph! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 7/12/2007 13:30'!
createClassBlueprint
	| view theClass |
	theClass := self currentNode theClass.
	view := MOClassBlueprint ofClass: theClass inPanel: self.
	^self createContentMorphWithView: view! !

!OBMondrianPanel methodsFor: 'morphic' stamp: 'dr 6/22/2007 14:41'!
createContentMorph
    ^self perform: ('create', visualization asString capitalized) asSymbol
! !

!OBMondrianPanel methodsFor: 'morphic' stamp: 'dr 6/22/2007 15:00'!
createContentMorphWithView: aView
    contentMorph := ScrollPane new
          borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill.

    contentMorph scroller addMorph: (MOViewer on: aView graph).
    ^contentMorph
! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 7/3/2007 10:37'!
createSystemComplexity
    ^self createContentMorphWithView: (MOPainting createSystemComplexityOf: self currentNode theClass)! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 7/3/2007 10:57'!
createUmlDiagram
	| view theClass |
	theClass := self currentNode theClass.
	view := MORenderer new.
	view layout: ((MOVerticalSpacedTreeLayout new)
				gap: [:ea | 10 @ 40];
				roots: [:each | Array with: (view elementOf: theClass)];
				children: [:each | each subclasses collect: [:ea | view elementOf: ea]]).
	view style: MOUmlClass new.
	view addAll: theClass withAllSubclasses.
	view layout: ((MOConnectorLayout new)
				source: [:each | view graph elementOf: each model key];
				sourcePosition: #topCenter;
				target: [:each | view graph elementOf: each model value];
				targetPosition: #bottomCenter).
	view style: MOUmlInheritance new.
	view 
		addAll: (theClass allSubclasses collect: [:each | each -> each superclass]).
	^ self createContentMorphWithView: view! !

!OBMondrianPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 15:24'!
currentNode
    ^self node ifNil: [super currentNode]! !

!OBMondrianPanel methodsFor: 'initializing' stamp: 'dr 6/22/2007 15:00'!
initialize
    super initialize.
    visualization := #systemComplexity! !

!OBMondrianPanel methodsFor: 'morphic' stamp: 'dr 6/29/2007 14:40'!
morph
    ^self createContentMorph! !

!OBMondrianPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 15:21'!
node
	^node! !

!OBMondrianPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 15:21'!
node: aNode
	node := aNode! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 6/22/2007 14:38'!
setVisualization: aSymbol
    visualization := aSymbol! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 6/29/2007 14:46'!
systemComplexity
    self setVisualization: #systemComplexity.
    ^self morph! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 6/29/2007 14:46'!
umlDiagram
	self setVisualization: #umlDiagram.
	^self morph! !

OBCmdRenameCat subclass: #OBCmdRenameSmartCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdRenameSmartCategory methodsFor: 'command' stamp: 'dr 4/16/2007 10:27'!
execute
	| category |
	category := OBTextRequest
				prompt: 'Please type new category name' 
				template: target name.
	category ifNotNil:	
		[target name: category.
		 requestor panel columns first refresh.]! !

!OBCmdRenameSmartCategory methodsFor: 'command' stamp: 'dr 4/16/2007 10:27'!
group
	^ #general! !

!OBCmdRenameSmartCategory methodsFor: 'command' stamp: 'dr 4/16/2007 15:53'!
isActive 
	^target isSmartGroupCategory! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 10:17'!
isMethodHolderNode
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 4/10/2007 11:22'!
isSmartGroup
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 4/16/2007 11:32'!
isSmartGroupCategory
    ^false! !

OBCodeNode subclass: #OBSmartAliasNode
	instanceVariableNames: 'node parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartAliasNode class methodsFor: 'as yet unclassified' stamp: 'dr 3/13/2007 18:10'!
node: aNode
    ^self new node: aNode! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:09'!
alias
	^self node! !

!OBSmartAliasNode methodsFor: 'actions' stamp: 'dr 4/10/2007 10:53'!
browse
    self node browse! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/3/2007 11:18'!
categories
	^ Smalltalk organization categories collect: [:cat | OBClassCategoryNode 
															on: cat
															inEnvironment: Smalltalk]! !

!OBSmartAliasNode methodsFor: 'displaying' stamp: 'dr 4/10/2007 11:11'!
indent
	| indent |
	indent := Text new: 4.
	indent atAllPut: $ .
	^ indent! !

!OBSmartAliasNode methodsFor: 'displaying' stamp: 'dr 4/10/2007 11:11'!
indentedName
	^ self indent, self name! !

!OBSmartAliasNode methodsFor: 'ancestry' stamp: 'dr 4/10/2007 11:30'!
isDescendantOf: aNode
    ^false! !

!OBSmartAliasNode methodsFor: 'ancestry' stamp: 'dr 4/10/2007 11:32'!
isDescendantOfClassCat: aClassCategoryNode
    ^false! !

!OBSmartAliasNode methodsFor: 'testing' stamp: 'dr 4/10/2007 11:21'!
isSmartGroup
    ^true! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:11'!
name
    ^self node name! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:08'!
node
	^node! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:08'!
node: aNode
	node := aNode! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/17/2007 15:38'!
packages
    ^self parentNode parentNode panel root packages! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:59'!
parentNode
	^parentNode! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:59'!
parentNode: aNode
	parentNode := aNode! !

!OBSmartAliasNode methodsFor: 'printing' stamp: 'dr 4/5/2007 14:37'!
printOn: aStream
    super printOn: aStream.
    aStream nextPutAll: ' ('.
    self node printOn: aStream. 
    aStream nextPut: $).! !

!OBSmartAliasNode methodsFor: 'adding/removing' stamp: 'dr 4/16/2007 16:00'!
remove
    ^self parentNode nodes remove: self.! !

OBCodeNode subclass: #OBSmartGroupNode
	instanceVariableNames: 'name nodes parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartGroupNode class methodsFor: 'as yet unclassified' stamp: 'dr 4/5/2007 17:04'!
name: aString
    ^self new name: aString! !

!OBSmartGroupNode methodsFor: 'adding/removing' stamp: 'dr 4/16/2007 10:47'!
addAlias: aNode
    ^self addNode: (OBSmartAliasNode node: aNode).! !

!OBSmartGroupNode methodsFor: 'adding/removing' stamp: 'dr 4/16/2007 15:58'!
addNode: aNode
    aNode parentNode: self.
    ^self nodes add: aNode! !

!OBSmartGroupNode methodsFor: 'drag and drop' stamp: 'dr 6/7/2007 16:19'!
dropSelector
    ^#dropOnSmartGroup:! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/10/2007 10:58'!
indentedName
    ^self name! !

!OBSmartGroupNode methodsFor: 'ancestry' stamp: 'dr 4/10/2007 11:33'!
isDescendantOfClassCat: aClassCategoryNode
    ^false! !

!OBSmartGroupNode methodsFor: 'testing' stamp: 'dr 4/10/2007 11:21'!
isSmartGroup
    ^true! !

!OBSmartGroupNode methodsFor: 'testing' stamp: 'dr 4/16/2007 11:32'!
isSmartGroupCategory
    ^true! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 6/7/2007 16:31'!
name.
	^name! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/5/2007 16:34'!
name: anObject
	name := anObject! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 10:48'!
nodes
    nodes ifNil: [nodes := OrderedCollection new].
    ^nodes! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:58'!
parentNode
	^parentNode! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:59'!
parentNode: aNode
	parentNode := aNode! !

!OBSmartGroupNode methodsFor: 'adding/removing' stamp: 'dr 4/16/2007 16:01'!
remove
    ^self parentNode nodes remove: self.! !

OBCodeNode subclass: #OBSmartRootNode
	instanceVariableNames: 'nodes panel'
	classVariableNames: 'Instances'
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartRootNode class methodsFor: 'as yet unclassified' stamp: 'dr 4/16/2007 16:29'!
default 
    Instances ifEmpty: [Instances add: self new].
    ^Instances last! !

!OBSmartRootNode class methodsFor: 'as yet unclassified' stamp: 'dr 4/16/2007 16:30'!
initialize
    "self initialize"
    Instances ifNil: [Instances := OrderedCollection new].! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/12/2007 17:12'!
addAlias: aNode
    ^self addNode: (OBSmartAliasNode node: aNode).! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 16:23'!
addNode: aNode
    aNode parentNode: self.
    ^self nodes add: aNode! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 16:02'!
allNodes
    ^self nodes inject: OrderedCollection new into: [:coll :ea | coll add: ea. coll addAll: ea nodes. coll].
! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:05'!
isDescendantOf: aNode
    ^false! !

!OBSmartRootNode methodsFor: 'navigating' stamp: 'dr 7/19/2007 15:37'!
name
    ^'smart root node'! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 7/19/2007 15:38'!
nodes
    | rootNode | 
    nodes ifNil: [
        rootNode := OBSmartGroupNode name: 'default'.
        rootNode addAlias: (OBClassNode on: Behavior).
        rootNode addAlias: (OBClassNode on: OBColumn).
        rootNode addAlias: (OBClassNode on: String).
        rootNode addAlias: (OBMethodNode on: #subclasses inClass: Class).  
	 
        nodes := OrderedCollection new.
        self addNode: rootNode.
    ].
    ^nodes
! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/17/2007 15:39'!
panel
	^panel! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/17/2007 15:39'!
panel: aPanel
	panel := aPanel! !

!OBBrowser methodsFor: '*ob-enhancements' stamp: 'dr 5/24/2007 12:21'!
definitionPanel
	^ panels 
		detect: [:ea | ea isDefinition] 
		ifNone: [self error: 'No definition panel configured']! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 7/19/2007 15:53'!
closableDefinitionPanel: aDefinitionPanel with: aBlock
	| morph contentMorph | 
	morph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.
     aDefinitionPanel codeTabPanel commands ifNotEmpty: [
	    morph addMorphBack: (aDefinitionPanel codeTabPanel buildOn: self).	
	].	
	aDefinitionPanel hasSeveralPanels ifTrue: [morph addMorphBack: aDefinitionPanel createTitleBar].	
	contentMorph := aDefinitionPanel createContentMorph.
	aDefinitionPanel setContentMorph: contentMorph.
	morph addMorphBack: contentMorph.
	
	current ifNotNil: [current addMorphBack: morph].
	^ self current: morph do: aBlock! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 7/18/2007 15:16'!
codeTabPanel: aCodeTabPanel with: aBlock
	| tabPanel |
	tabPanel _ OBRadioButtonBar
					on: aCodeTabPanel
					list: #list
					selected: #selection
					changeSelected: #selection:.
	tabPanel height: 23;
		      hResizing: #shrinkWrap;
		      vResizing: #shrinkWrap;
		      cellInset: aCodeTabPanel cellInset;	
	           cellPositioning: #topLeft.	
	tabPanel adoptPaneColor: aCodeTabPanel browser defaultBackgroundColor darker darker darker.	
		
	current ifNotNil: [current addMorphBack: tabPanel].
	^ self current: tabPanel do: aBlock! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 6/14/2007 10:29'!
multipleDefinitionPanel: aMultipleDefinitionPanel with: aBlock
	| morph |
	morph _ (OBPaneScroller withModel: aMultipleDefinitionPanel)
		name: 'def';
		yourself.		
	current ifNotNil: [current addMorphBack: morph].
	^ self current: morph do: aBlock! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 6/14/2007 10:27'!
multipleSelectionColumn: aColumn with: aBlock
   	| pane |
     pane := self createPaneForColumn: aColumn with: #multipleSelectionListMorphForColumn:.
	current ifNotNil: [current pushPane: pane].
	^ self current: pane do: aBlock
! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 6/14/2007 10:23'!
multipleSelectionListMorphForColumn: aColumn
	^ (OBPluggableListMorphOfMany
		on: aColumn
		list: #list
		primarySelection: #selection
		changePrimarySelection: #selection:
		listSelection: #listSelectionAt:
		changeListSelection: #listSelectionAt:put:		
		menu: #menu:
		keystroke: #keystroke:from:)
			getListElementSelector: #listAt:;
			getListSizeSelector: #listSize;
			dragEnabled: aColumn dragEnabled;
			dropEnabled: aColumn dropEnabled;
			borderWidth: 0;
			autoDeselect: false;
			yourself! !

OBPanel subclass: #OBCodeTabPanel
	instanceVariableNames: 'definitionPanel selection commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

!OBCodeTabPanel methodsFor: 'morphic' stamp: 'dr 7/18/2007 15:37'!
buildOn: aBuilder
     ^aBuilder codeTabPanel: self with: []! !

!OBCodeTabPanel methodsFor: 'configuration' stamp: 'dr 7/12/2007 14:27'!
cellInset
    ^5! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 6/22/2007 17:00'!
color
	^browser defaultBackgroundColor ! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 7/3/2007 15:04'!
commands
	| tmpCommands |
	self node ifNil: [^ #()].
	tmpCommands _ (self announce: OBNodeCommandScan) commandsOn: self node for: self. 
	commands := (tmpCommands select: [:ea | ea wantsTabButton]) asSortedCollection: [:a :b | (a priority < b priority) or: [a priority = b priority and: [a label <= b label]]].
	^commands! !

!OBCodeTabPanel methodsFor: 'configuration' stamp: 'dr 7/19/2007 16:05'!
defaultLabelSelector
    ^#shortLabel! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 6/28/2007 10:58'!
definitionPanel
    ^definitionPanel! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 6/28/2007 10:45'!
definitionPanel: aDefinitionPanel
    definitionPanel := aDefinitionPanel! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 7/12/2007 14:55'!
executeCommand
     (commands at: self selection) execute.! !

!OBCodeTabPanel methodsFor: 'initializing' stamp: 'dr 6/29/2007 16:26'!
initialize
    super initialize.
    selection := 1.! !

!OBCodeTabPanel methodsFor: 'testing' stamp: 'dr 7/19/2007 16:06'!
isEnabled: aButtonModel
    ^(self commands detect: [:ea | (ea perform: self defaultLabelSelector) = aButtonModel label] 
                        ifNone: [^false]) isActive.! !

!OBCodeTabPanel methodsFor: 'testing' stamp: 'dr 6/28/2007 10:37'!
isTab
    ^true! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 7/19/2007 16:05'!
list 
    ^self commands collect: [:ea | ea perform: self defaultLabelSelector]! !

!OBCodeTabPanel methodsFor: 'morphic' stamp: 'dr 7/12/2007 14:32'!
maxWidth
    ^self commands inject: 0 into: [:width :cmd | width := width + (cmd label size * 7 + self cellInset). width]! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 16:01'!
node
    ^self definitionPanel currentOrRootNode! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 6/22/2007 17:19'!
panel
    ^self! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 6/28/2007 16:07'!
selection
	^selection! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 7/12/2007 14:56'!
selection: anInteger
	selection := anInteger.
     self executeCommand.
	self changed: #selection.! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 7/19/2007 14:54'!
selectionChanged: ann
	self changed: #list! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 6/29/2007 14:21'!
subscribe
	self announcer
		observe: OBSelectionChanged
		send: #selectionChanged:
		to: self! !

OBPanel subclass: #OBMultipleDefinitionPanel
	instanceVariableNames: 'panels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/21/2007 16:44'!
aboutToChange: ann
   " self panels first aboutToChange: ann."! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/28/2007 11:13'!
addPanel: aPanel
    "remove empty standard panel"
    (panels size = 1 and: [panels first node isNil]) ifTrue: [panels := OrderedCollection new].

    aPanel owner: self.
    panels add: aPanel.

    "make sure that the first panel also get buttons as soon as a second panel is added"
    panels size = 2 ifTrue: [panels first createMorph].

    self browser ifNotNil: [aPanel browser: self browser].
    self changed: #columns! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/8/2007 11:40'!
browser: aBrowser
    super browser: aBrowser.
    self panels do: [:ea | ea browser: aBrowser].! !

!OBMultipleDefinitionPanel methodsFor: 'building' stamp: 'dr 6/12/2007 16:11'!
buildOn: aBuilder
	^ aBuilder multipleDefinitionPanel: self with: []! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/12/2007 16:12'!
columns
   ^self panels! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/8/2007 11:29'!
defaultBackgroundColor
	^ browser defaultBackgroundColor! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/29/2007 15:55'!
definitionChanged: ann
    "self panels first definition: ann definition.
    self panels first definitionChanged: ann."! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/7/2007 11:36'!
hasChangeablePanel
    ^self panels anySatisfy: [:ea | ea isChangeable].! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/25/2007 17:29'!
hasMethodPanel
    ^self panels anySatisfy: [:ea | ea node isKindOf: OBMethodNode].! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/29/2007 10:40'!
includesNode: aNode
    ^self panels anySatisfy: [:ea | ea node = aNode].! !

!OBMultipleDefinitionPanel methodsFor: 'initializing' stamp: 'dr 6/7/2007 11:55'!
initialize
    panels := OrderedCollection new.    
    self addPanel: OBClosableDefinitionPanel new.
    ! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/14/2007 10:39'!
insert: firstPanel after: secondPanel
    | removeIdx |
    removeIdx := self panels indexOf: firstPanel.
    self panels add: firstPanel after: secondPanel.
    self panels removeAt: removeIdx.
    self changed: #columns.! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/14/2007 10:39'!
insert: firstPanel before: secondPanel
    | removeIdx |
    removeIdx := self panels indexOf: firstPanel.
    self panels add: firstPanel before: secondPanel.
    self panels removeAt: (removeIdx + 1).
    self changed: #columns.! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:45'!
is: firstClosableDefinitionPanel placedBefore: secondClosableDefinitionPanel
    ^(self panels indexOf: firstClosableDefinitionPanel) < (self panels indexOf: secondClosableDefinitionPanel)! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/24/2007 12:20'!
isDefinition
   ^true! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/7/2007 11:50'!
lastChangeablePanel "self halt."
    ^self panels reversed detect: [:ea | ea isChangeable] ifNone: [nil].! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/31/2007 17:12'!
lastIsNonMetaPanel
    ^(self lastPanel node isKindOf: OBMethodNode) not and: [self lastPanel isKindOf: OBClosableDefinitionPanel]! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/31/2007 17:06'!
lastPanel
    ^self panels last! !

!OBMultipleDefinitionPanel methodsFor: 'constructing' stamp: 'dr 5/8/2007 11:27'!
morph
	^ (OBPaneScroller withModel: self)
		name: 'def';
		yourself! !

!OBMultipleDefinitionPanel methodsFor: 'constructing' stamp: 'dr 5/8/2007 11:32'!
morphHeight
	^ 0! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/25/2007 15:28'!
nodeDeleted: ann
    | deletedNodePanel  |
    (ann node isKindOf: OBMethodNode) ifTrue: [
	   deletedNodePanel := self panels detect: [:ea | ea node = ann node] ifNone: [nil].
	   deletedNodePanel ifNotNil: [self removePanel: deletedNodePanel column: nil]
    ].! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/24/2007 12:27'!
panels
   ^panels! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/8/2007 11:26'!
panes
    ^panels collect: [:ea | ea morph]! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/8/2007 11:44'!
reclaimPanes
    ^0! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/18/2007 11:40'!
refresh: ann
    self panels first refresh: ann.! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/25/2007 18:00'!
removeNonMethodPanels
	self panels copy do: [:ea | (ea node isKindOf: OBMethodNode) ifFalse: [self removePanel: ea]]! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/25/2007 17:55'!
removePanel: aPanel
    ^self removePanel: aPanel column: nil! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/14/2007 10:39'!
removePanel: aPanel column: aColumn
    | newPanel theClass |
    panels remove: aPanel.
 
    "make sure that the last panels does not have any buttons"
    panels size = 1 ifTrue: [panels first createMorph].
    
    "make sure that there is always at least a standard panel"
    panels ifEmpty: [ 
	    newPanel := OBClosableDefinitionPanel new. 
	    aColumn ifNotNil: [newPanel definition: aColumn selectedNode definition]
	               ifNil: [aPanel node ifNotNil: [theClass := aPanel node theClass.
			            newPanel definition: (OBMethodDefinition source: theClass sourceCodeTemplate inClass: theClass)]]. 
	    self addPanel: newPanel.
    ].
    self changed: #columns! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 7/17/2007 10:13'!
selectionChanged: ann
    | newPanel newDefinition deselectedPanel panel |
    self flag: #toRefactor.

	ann deselectedNode ifNotNil: [
       deselectedPanel := self panels detect: [:ea | ea node = ann deselectedNode] ifNone: [nil].
       deselectedPanel ifNotNil: [self removePanel: deselectedPanel column: ann column]
	] ifNil: [.
        (self panels noneSatisfy: [:ea | ea node = ann node]) ifTrue: [
	       newDefinition := ann node ifNotNil: [ann node definition].
		  (newDefinition notNil and: [newDefinition text notEmpty]) ifTrue: [
	           (self hasChangeablePanel and: [ActiveEvent isNil or: [ActiveEvent shiftPressed not]]) ifTrue: [
		             self lastChangeablePanel definition: newDefinition.
		             self lastChangeablePanel node: ann node.
		             self lastChangeablePanel changed. 
		             self changed: #columns. 		
		       ] ifFalse: [
                      newPanel := OBClosableDefinitionPanel new.
                      newPanel definition: newDefinition.
                      newPanel node: ann node.
                      self addPanel: newPanel.
                ].
             ] 
         ] ifFalse: [
                "update panel for this node with new source code"
                panel := self panels detect: [:ea | ea node = ann node].
                panel definition: ann node definition.
         ].
     ].! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/29/2007 15:28'!
sizing 
    self panels ifEmpty: [^1].
    ^self panels size! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/25/2007 14:57'!
subscribe
	self announcer 
		observe: OBAboutToChange
		send: #aboutToChange:
		to: self;
		
		observe: OBSelectionChanged
		send: #selectionChanged:
		to: self;
		
		observe: OBRefreshRequired
		send: #refresh:
		to: self;
				
		observe: OBDefinitionChanged
		send: #definitionChanged: 
		to: self;
		
		observe: OBNodeDeleted
		send: #nodeDeleted: 
		to: self.! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/14/2007 10:39'!
swap: firstPanel with: secondPanel
    self panels swap: (self panels indexOf: firstPanel) with: (self panels indexOf: secondPanel).
    self changed: #columns.
"self halt."! !

!OBPanel methodsFor: '*ob-enhancements' stamp: 'dr 5/24/2007 12:20'!
isDefinition
   ^false! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 5/25/2007 17:06'!
isMethodHolderNode
    ^true! !

!OBCodeBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 7/18/2007 16:14'!
useMultipleSelection
    ^false! !

OBSystemBrowser subclass: #OBMultipleSelectionBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-MultipleSelection'!

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 7/18/2007 16:09'!
definitionPanel
	^ OBMultipleDefinitionPanel new! !

!OBMultipleSelectionBrowser class methodsFor: 'initializing' stamp: 'dr 7/19/2007 16:10'!
initialize
	self registerInOpenMenu! !

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 7/18/2007 16:17'!
methodColumnIndex
    ^4! !

!OBMultipleSelectionBrowser class methodsFor: 'initializing' stamp: 'dr 7/19/2007 16:08'!
registerInOpenMenu
	TheWorldMenu registerOpenCommand: {'Image Browser'. {self. #open}}.! !

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 7/18/2007 16:15'!
useMultipleSelection
    ^true! !

!OBMultipleSelectionBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:37'!
cmdClassBlueprint
	^OBCmdClassBlueprint! !

!OBMultipleSelectionBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:37'!
cmdSourceCode
	^ OBCmdSourceCode! !

!OBMultipleSelectionBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:37'!
cmdSystemComplexity
	^ OBCmdSystemComplexity! !

!OBMultipleSelectionBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:37'!
cmdUmlDiagram
	^OBCmdUmlDiagram! !

OBMultipleSelectionBrowser subclass: #OBSmartGroupBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 7/19/2007 10:28'!
defaultMetaNode
    | env smartGroupMetaNode |
    env := super defaultMetaNode.
    smartGroupMetaNode := OBMetaNode named: 'SmartGroup'.
    smartGroupMetaNode
		displaySelector: #indentedName;
		childAt: #allNodes put: env.
    env displaySelector: #indentedName. 

    ^smartGroupMetaNode       ! !

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 4/17/2007 16:25'!
imageClass: classSel comment: commentSel metaclass: metaclassSel 
    | env smartGroupMetaNode |
    env := super imageClass: classSel comment: commentSel metaclass: metaclassSel.
    smartGroupMetaNode := OBMetaNode named: 'SmartGroup'.
    smartGroupMetaNode
		displaySelector: #indentedName;
		childAt: #allNodes put: env.
    env displaySelector: #indentedName. 

    ^smartGroupMetaNode       ! !

!OBSmartGroupBrowser class methodsFor: 'initializing' stamp: 'dr 5/8/2007 15:41'!
initialize
	self registerInOpenMenu! !

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 7/18/2007 16:17'!
methodColumnIndex
    ^5! !

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 7/19/2007 10:47'!
navigationPanel
	^OBSmartGroupColumnPanel minPanes: self minPanes maxPanes: self maxPanes! !

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 4/24/2007 15:38'!
paneCount
    ^5! !

!OBSmartGroupBrowser class methodsFor: 'initializing' stamp: 'dr 5/8/2007 15:40'!
registerInOpenMenu
     "self registerInOpenMenu"
	TheWorldMenu registerOpenCommand: {'SmartGroup Browser'. {self. #open}}.! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:40'!
cmdAddSmartCategory
	^OBCmdAddSmartCategory! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:40'!
cmdAddToSmartGroup
	^OBCmdAddToSmartGroup! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:41'!
cmdRemoveFromSmartGroup
	^OBCmdRemoveFromSmartGroup! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:41'!
cmdRenameSmartCategory
	^OBCmdRenameSmartCategory! !

PluggableListMorphOfMany subclass: #OBPluggableListMorphOfMany
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Morphs'!

!OBPluggableListMorphOfMany methodsFor: 'list management' stamp: 'dr 7/17/2007 16:12'!
getIconsForRow: index
    ^model getIconsForRow: index! !

!OBPluggableListMorphOfMany methodsFor: 'list management' stamp: 'dr 7/17/2007 16:07'!
hasIconAt: index
    ^model hasIconAt: index! !

!OBPluggableListMorphOfMany methodsFor: 'list management' stamp: 'dr 6/7/2007 15:53'!
listMorphClass
    ^OBLazyListMorph! !

OBColumnPanel subclass: #OBSmartGroupColumnPanel
	instanceVariableNames: 'smartGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

OBSmartGroupColumnPanel class
	instanceVariableNames: 'smartGroup'!

OBSmartGroupColumnPanel class
	instanceVariableNames: 'smartGroup'!

!OBSmartGroupColumnPanel methodsFor: 'navigating' stamp: 'dr 7/19/2007 10:37'!
selectPath: aCollection
	| column parent |
	column_ smartGroup ifNil: [columns first] ifNotNil: [columns second].
	parent _ self root.
	aCollection do:
		[:node |
		column parent: parent child: node.
		column _ column next.
		parent _ node].! !

!OBSmartGroupColumnPanel methodsFor: 'updating' stamp: 'dr 7/19/2007 10:38'!
selectionChanged: ann
     (ann column isKindOf: OBSmartGroupColumn) ifTrue: [^self].
     super selectionChanged: ann.! !

!OBSmartGroupColumnPanel methodsFor: 'initializing' stamp: 'dr 7/19/2007 10:48'!
setMetaNode: aMetaNode node: aNode 
	| metaNode |
	metaNode := aMetaNode.	
	metaNode name = 'SmartGroup' ifTrue: [
	    metaNode := (aMetaNode children detect: [:ea | ea name = 'Environment']).	
	    smartGroup := OBSmartRootNode default.
	    smartGroup panel: self.
	    self pushColumn: (OBSmartGroupColumn 
				inPanel: self
				metaNode: aMetaNode
				node: smartGroup).		
	].
	super setMetaNode: metaNode node: aNode.! !

!OBSmartGroupColumnPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 11:01'!
smartGroup
    ^smartGroup! !

!OBMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 5/25/2007 17:07'!
isMethodHolderNode
    ^true! !

OBCommand subclass: #OBCmdAddSmartCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 4/16/2007 15:52'!
execute
	| name |
	name := OBTextRequest 
					prompt: 'Please type new category name' 
					template: ''.
	name ifNil: [^self].

    requestor panel smartGroup addNode: (OBSmartGroupNode name: name).
    requestor panel columns first refresh.! !

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 4/10/2007 11:18'!
group
	^ #general! !

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 4/10/2007 11:25'!
isActive 
	^ target isSmartGroup! !

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 4/10/2007 11:18'!
label
    ^'new category...'! !

OBCommand subclass: #OBCmdAddToSmartGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 7/19/2007 13:55'!
execute
    | selection smartGroups |

    smartGroups := requestor panel smartGroup nodes select: [:ea | ea isSmartGroupCategory].

    selection := OBChoiceRequest prompt: nil labels: (smartGroups collect: [:ea | ea name]) values: smartGroups.
    selection ifNotNil: [selection addAlias: target].

    requestor panel columns first refresh.
    self select: target with: requestor announcer! !

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 13:27'!
group
	^ #navigation! !

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 5/29/2007 17:22'!
isActive
	^(requestor browser isKindOf: OBSmartGroupBrowser) and: [target isSmartGroup not
		and: [requestor isSelected: target]]! !

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 13:27'!
label
    ^'add to smart group'! !

OBCommand subclass: #OBCmdClassBlueprint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdClassBlueprint methodsFor: 'command' stamp: 'dr 7/19/2007 15:24'!
execute
     | defPanel mondrianPanel |
     defPanel := requestor definitionPanel.
     mondrianPanel := OBMondrianPanel new browser: defPanel browser; node: defPanel node.
	defPanel exchangeContentWith: mondrianPanel classBlueprint.! !

!OBCmdClassBlueprint methodsFor: 'command' stamp: 'dr 7/3/2007 14:57'!
group
	^ #identity! !

!OBCmdClassBlueprint methodsFor: 'testing' stamp: 'dr 7/3/2007 14:57'!
isActive
	^(requestor isKindOf: OBCodeTabPanel) and: [target respondsTo: #theClass]! !

!OBCmdClassBlueprint methodsFor: 'command' stamp: 'dr 7/3/2007 14:57'!
label
    ^'Class Blueprint'! !

!OBCmdClassBlueprint methodsFor: 'sorting' stamp: 'dr 7/3/2007 15:00'!
priority
    ^2! !

!OBCmdClassBlueprint methodsFor: 'command' stamp: 'dr 7/12/2007 14:35'!
shortLabel
    ^'Cl. Bluep.'! !

!OBCmdClassBlueprint methodsFor: 'testing' stamp: 'dr 7/3/2007 14:57'!
wantsTabButton
    ^true! !

OBCommand subclass: #OBCmdRemoveFromSmartGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 7/19/2007 13:57'!
execute
    target remove.
    requestor panel columns first refresh.
    self select: target with: requestor announcer! !

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 15:43'!
group
	^ #navigation! !

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 4/16/2007 15:55'!
isActive
	^target isSmartGroup
		and: [requestor isSelected: target]! !

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 15:43'!
label
    ^'remove'! !

OBCommand subclass: #OBCmdSourceCode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBCmdSourceCode methodsFor: 'command' stamp: 'dr 6/29/2007 16:32'!
execute
	requestor definitionPanel selectSourceTab! !

!OBCmdSourceCode methodsFor: 'command' stamp: 'dr 6/28/2007 10:28'!
group
	^ #identity! !

!OBCmdSourceCode methodsFor: 'testing' stamp: 'dr 7/19/2007 15:04'!
isActive
	^requestor isKindOf: OBCodeTabPanel! !

!OBCmdSourceCode methodsFor: 'command' stamp: 'dr 6/28/2007 10:27'!
label
    ^'Source Code'! !

!OBCmdSourceCode methodsFor: 'sorting' stamp: 'dr 7/3/2007 15:01'!
priority
    ^1! !

!OBCmdSourceCode methodsFor: 'command' stamp: 'dr 7/12/2007 14:36'!
shortLabel
    ^'Src C.'! !

!OBCmdSourceCode methodsFor: 'testing' stamp: 'dr 6/28/2007 16:25'!
wantsTabButton
    ^true! !

OBCommand subclass: #OBCmdSystemComplexity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBCmdSystemComplexity methodsFor: 'command' stamp: 'dr 7/19/2007 15:22'!
execute
     | defPanel mondrianPanel |
     defPanel := requestor definitionPanel.
     mondrianPanel := OBMondrianPanel new browser: defPanel browser; node: defPanel node.
	defPanel exchangeContentWith: mondrianPanel systemComplexity.! !

!OBCmdSystemComplexity methodsFor: 'command' stamp: 'dr 6/15/2007 16:49'!
group
	^ #identity! !

!OBCmdSystemComplexity methodsFor: 'testing' stamp: 'dr 6/28/2007 11:24'!
isActive
	^(requestor isKindOf: OBCodeTabPanel) and: [target respondsTo: #theClass]! !

!OBCmdSystemComplexity methodsFor: 'command' stamp: 'dr 6/15/2007 16:49'!
label
    ^'System Complexity'! !

!OBCmdSystemComplexity methodsFor: 'sorting' stamp: 'dr 7/3/2007 15:02'!
priority
    ^2! !

!OBCmdSystemComplexity methodsFor: 'command' stamp: 'dr 7/12/2007 14:34'!
shortLabel
    ^'Sys. Complex.'! !

!OBCmdSystemComplexity methodsFor: 'testing' stamp: 'dr 6/28/2007 16:24'!
wantsTabButton
    ^true! !

OBCommand subclass: #OBCmdUmlDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdUmlDiagram methodsFor: 'command' stamp: 'dr 7/19/2007 15:25'!
execute
     | defPanel mondrianPanel |
     defPanel := requestor definitionPanel.
     mondrianPanel := OBMondrianPanel new browser: defPanel browser; node: defPanel node.
	defPanel exchangeContentWith: mondrianPanel umlDiagram.! !

!OBCmdUmlDiagram methodsFor: 'command' stamp: 'dr 6/19/2007 15:58'!
group
	^ #identity! !

!OBCmdUmlDiagram methodsFor: 'testing' stamp: 'dr 7/16/2007 12:06'!
isActive
	^(requestor isKindOf: OBCodeTabPanel) and: [target respondsTo: #theClass]! !

!OBCmdUmlDiagram methodsFor: 'command' stamp: 'dr 6/19/2007 15:58'!
label
    ^'UML Diagram'! !

!OBCmdUmlDiagram methodsFor: 'sorting' stamp: 'dr 7/3/2007 15:02'!
priority
    ^2! !

!OBCmdUmlDiagram methodsFor: 'command' stamp: 'dr 7/12/2007 14:34'!
shortLabel
    ^'UML Diag.'! !

!OBCmdUmlDiagram methodsFor: 'testing' stamp: 'dr 6/28/2007 16:25'!
wantsTabButton
    ^true! !

!OBCommand methodsFor: '*ob-enhancements' stamp: 'dr 6/28/2007 16:24'!
wantsTabButton
    ^false! !

OBSystemBrowserAdaptor subclass: #OBMultipleSelectionBrowserAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-MultipleSelection'!

!OBMultipleSelectionBrowserAdaptor class methodsFor: 'configuration' stamp: 'dr 7/19/2007 16:36'!
browserClass
    ^OBMultipleSelectionBrowser! !

!OBMultipleSelectionBrowserAdaptor class methodsFor: 'initializing' stamp: 'dr 7/19/2007 16:37'!
initialize
     "self initialize"
	self register! !

PluggableButtonMorph subclass: #OBDraggableButtonMorph
	instanceVariableNames: 'dropOn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Morphs'!

!OBDraggableButtonMorph commentStamp: 'dr 6/12/2007 15:21' prior: 0!
I represent a button morph which is draggable. Other draggable button morphs can be dropped on me.!

!OBDraggableButtonMorph methodsFor: 'events-processing' stamp: 'dr 6/11/2007 15:44'!
acceptDroppingMorph: aMorph event: evt 
     model dropMorph: aMorph.
	
	self resetDropOn.
	evt hand releaseMouseFocus: self.
	Cursor normal show. 
! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/8/2007 15:25'!
click: evt
    super mouseDown: evt! !

!OBDraggableButtonMorph methodsFor: 'drawing' stamp: 'dr 6/11/2007 11:27'!
drawOn: aCanvas
	super drawOn: aCanvas. 
	
    dropOn ifNotNil: ["self halt."self highlightOn: aCanvas].! !

!OBDraggableButtonMorph methodsFor: 'drawing' stamp: 'dr 6/11/2007 11:39'!
highlightOn: aCanvas
	| topLeft drawBounds |
	topLeft := self topLeft x @ (self topLeft y + 1).
	drawBounds := topLeft extent: self width @ (self height + 1).
	drawBounds := drawBounds intersect: self bounds.
	aCanvas frameRectangle: self innerBounds width: 1 color: Color blue! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/8/2007 15:26'!
mouseDown: evt
	| selectors |
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].

	selectors _ Array 
		with: #click:
		with: nil
		with: nil
		with: #startDrag:.
	evt hand waitForClicksOrDrag: self event: evt selectors: selectors threshold: 10.! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/11/2007 11:34'!
mouseEnterDragging: evt
	(self dropEnabled and: [evt hand hasSubmorphs]) ifFalse: [^super mouseEnterDragging: evt].
	
	(self wantsDroppedMorph: evt hand firstSubmorph event: evt)
		ifTrue: [
			dropOn := true.
			
			evt hand newMouseFocus: self.
			"test ifNil: [test := (evt hand firstSubmorph passenger == model). ""evt hand firstSubmorph passenger insertAfter: model."
				
			self changed.
		].! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/11/2007 11:16'!
mouseLeaveDragging: evt.
	(self dropEnabled and: [evt hand hasSubmorphs]) ifFalse: [^super mouseLeaveDragging: evt].
	self resetDropOn.
	evt hand releaseMouseFocus: self.! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/8/2007 16:21'!
mouseMove: evt
		
	"self = (self rowAtLocation: evt position) ifTrue: [^self]." 
	(self dropEnabled and: [evt hand hasSubmorphs]) ifFalse: [^super mouseMove: evt].
		
	self mouseLeaveDragging: evt.
	(self containsPoint: evt position) ifTrue: [self mouseEnterDragging: evt].! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/11/2007 11:18'!
resetDropOn
    dropOn ifNotNil: [dropOn := nil. self changed].! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/8/2007 15:54'!
startDrag: evt 
	| ddm |
	evt hand hasSubmorphs ifTrue: [^self].

	[  (self dragEnabled and: [model okToChange]) ifFalse: [^self].
	   ddm := TransferMorph withPassenger: model from: self.
        evt hand grabMorph: ddm]
	ensure: [Cursor normal show. evt hand releaseMouseFocus: self]! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/11/2007 11:33'!
wantsDroppedMorph: transferMorph event: evt
	(transferMorph isKindOf: TransferMorph) ifFalse: [^false].
	(transferMorph passenger isKindOf: model class) ifFalse: [^false]. 
	transferMorph passenger == model ifTrue: [^false].
	
     ^true! !
OBSmartRootNode initialize!
OBMultipleSelectionBrowser initialize!
OBSmartGroupBrowser initialize!
OBMultipleSelectionBrowserAdaptor initialize!
